/********************************************************************************
 *      Copyright:  (C) Guo Wenxue <guowenxue@gmail.com>
 *                  All rights reserved.
 *
 *       Filename:  core_mqtt.h
 *    Description:  This head file is MQTT client API based on Paho MQTT Embedded
 *
 *   ChangeLog:
 *        Version   Date        Author         Description
 *        V1.0.0  2021.08.26  GuoWenxue   Release initial version.
 *
 ********************************************************************************/

#ifndef  _CORE_MQTT_H_
#define  _CORE_MQTT_H_

#include "MQTTPacket.h"
#include "transport.h"

#define MQTT_KEEP_ALIVE_TIMEOUT_SECONDS        ( 60U )

enum
{
    Qos0=0,
    Qos1,
    Qos2,
};

extern int mqtt_connect(char *host, int port, char *clentid, char *username, char *passwd);

extern int mqtt_disconnect(void);

extern int mqtt_subscribe_topic(char *topic, int qos, int msgid);

extern int mqtt_unsubscribe_topic(char *topic, int msgid);

extern int mqtt_publish(char *topic, int qos, char *payload);

extern int mqtt_pingreq(void);

#endif   /* ----- #ifndef _CORE_MQTT_H_  ----- */
