/**********************************************************************
*   Copyright: (C)2021 LingYun IoT System Studio <www.weike-iot.com>
*      Author: GuoWenxue<guowenxue@gmail.com> QQ: 281143292
* Description: BearKE1 NB-IoT Board OLED Hardware Abstract Layer source code
*
*   ChangeLog:
*        Version    Date       Author            Description
*        V1.0.0  2021.08.10  GuoWenxue      Release initial version
***********************************************************************/
#ifndef __HAL_OLED_H_
#define __HAL_OLED_H_

#include "stm32l4xx_hal.h"
      
#define OLED_I2CWR_ADDR            0x78         /* OLED chip write address D/C#=0(SA=0); R/W#=0(Write) */

#define X_WIDTH 		           128
#define Y_WIDTH 		           64

#define OLED_FONT16                16
#define OLED_FONT8                 8

/*
 *+-------------------------------------------------+
 *|        OLED initial/control function API        |
 *+-------------------------------------------------+
 */ 
void OLED_Init(void);
void OLED_On(void); 
void OLED_Clear(void);
void OLED_Display_On(void);
void OLED_Display_Off(void);	   	

/*
 *+-------------------------------------------------+
 *|          OLED display function API              |
 *+-------------------------------------------------+
 */ 
void OLED_Set_Pos(uint8_t x, uint8_t y);
void OLED_ShowNum(uint8_t x,uint8_t y,uint32_t num,uint8_t len,uint8_t size);
void OLED_ShowString(uint8_t x,uint8_t y, char *p,uint8_t font_size);	 
void OLED_ShowChinese(uint8_t (*Hzk)[32], uint8_t x,uint8_t y,uint8_t no);
void OLED_DrawBMP(uint8_t x0, uint8_t y0, uint8_t x1, uint8_t y1, uint8_t *BMP);

	
#endif /* endof __HAL_OLED_H_*/
