/**********************************************************************
*   Copyright: (C)2021 LingYun IoT System Studio <www.weike-iot.com>
*      Author: GuoWenxue<guowenxue@gmail.com> QQ: 281143292
* Description: BearKE1 NB-IoT Board OLED display test source code
*
*      Notice: Must implement delay_us() by timer in tim.h first.
*
*   ChangeLog:
*        Version    Date       Author            Description
*        V1.0.0  2021.08.10  GuoWenxue      Release initial version
***********************************************************************/
#ifndef __OLED_H_
#define __OLED_H_

#include "hal_oled.h"

/*
 *+-------------------------------------------------+
 *|            OLED Board display API               |
 *+-------------------------------------------------+
 */ 
#define TIME_500MS     500
#define TIME_1S        1000

void OLED_ShowBanner(int showtime);

void OLED_ShowTempHumdity(uint32_t temp, uint32_t humd, int showtime);

void OLED_ShowLightNoisy(uint32_t light, uint32_t noisy, int showtime);

#endif
